Subject: Re: [Intel-wired-lan] [iwl-net v1] ice: tc: do default match on all profiles

From: Michal Swiatkowski <[email-masked]>
Date: Wed, 10 Apr 2024 11:57:55 +0200

On Fri, Apr 05, 2024 at 10:43:04AM +0200, Michal Swiatkowski wrote:
> On Mon, Apr 01, 2024 at 09:28:30AM +0000, Buvaneswaran, Sujai wrote:
> > > -----Original Message-----
> > > From: Michal Swiatkowski <[email-masked]>
> > > Sent: Friday, March 29, 2024 1:56 PM
> > > To: Buvaneswaran, Sujai <[email-masked]>
> > > Cc: [email-masked]; [email-masked]; Marcin Szycik
> > > <[email-masked]>; Kubiak, Michal <[email-masked]>
> > > Subject: Re: [Intel-wired-lan] [iwl-net v1] ice: tc: do default match on all
> > > profiles
> > > 
> > > On Mon, Mar 25, 2024 at 06:36:56AM +0000, Buvaneswaran, Sujai wrote:
> > > > > -----Original Message-----
> > > > > From: Intel-wired-lan <[email-masked]> On Behalf
> > > > > Of Michal Swiatkowski
> > > > > Sent: Tuesday, March 12, 2024 4:23 PM
> > > > > To: [email-masked]
> > > > > Cc: [email-masked]; Marcin Szycik
> > > > > <[email-masked]>; Kubiak, Michal
> > > > > <[email-masked]>; Michal Swiatkowski
> > > > > <[email-masked]>
> > > > > Subject: [Intel-wired-lan] [iwl-net v1] ice: tc: do default match on
> > > > > all profiles
> > > > >
> > > > > A simple non-tunnel rule (e.g. matching only on destination MAC) in
> > > > > hardware will be hit only if the packet isn't a tunnel. In software
> > > > > execution of the same command, the rule will match both tunnel and
> > > non-tunnel packets.
> > > > >
> > > > > Change the hardware behaviour to match tunnel and non-tunnel packets
> > > > > in this case. Do this by considering all profiles when adding
> > > > > non-tunnel rule (rule not added on tunnel, or not redirecting to tunnel).
> > > > >
> > > > > Example command:
> > > > > tc filter add dev pf0 ingress protocol ip flower skip_sw action mirred \
> > > > > 	egress redirect dev pr0
> > > > >
> > > > > It should match also tunneled packets, the same as command with
> > > > > skip_hw will do in software.
> > > > >
> > > > > Fixes: 9e300987d4a8 ("ice: VXLAN and Geneve TC support")
> > > > > Reviewed-by: Marcin Szycik <[email-masked]>
> > > > > Reviewed-by: Michal Kubiak <[email-masked]>
> > > > > Signed-off-by: Michal Swiatkowski
> > > > > <[email-masked]>
> > > > > ---
> > > > > v1 --> v2:
> > > > >  * fix commit message sugested by Marcin
> > > > > ---
> > > > >  drivers/net/ethernet/intel/ice/ice_tc_lib.c | 2 +-
> > > > >  1 file changed, 1 insertion(+), 1 deletion(-)
> > > > >
> > > > Hi,
> > > >
> > > > We are seeing error while adding HW tc rules on PF with the latest net-
> > > queue patches. This issue is blocking the validation of latest net-queue
> > > Switchdev patches.
> > > >
> > > > + tc filter add dev ens5f0np0 ingress protocol ip prio 1 flower
> > > > + src_mac b4:96:91:9f:65:58 dst_mac 52:54:00:00:16:01 skip_sw action
> > > > + mirred egress redirect dev eth0
> > > > Error: ice: Unable to add filter due to error.
> > > > We have an error talking to the kernel
> > > > + tc filter add dev ens5f0np0 ingress protocol ip prio 1 flower
> > > > + src_mac b4:96:91:9f:65:58 dst_mac 52:54:00:00:16:02 skip_sw action
> > > > + mirred egress redirect dev eth1
> > > > Error: ice: Unable to add filter due to error.
> > > > We have an error talking to the kernel
> > > 
> > > Hi,
> > > 
> > > The same command is working fine on my setup. I suspect that it isn't related
> > > to this patch. The change is only in command validation, there is no
> > > functional changes here that can cause error during adding filters which
> > > previously was working fine.
> > > 
> > > Can you share more information about the setup? It was the first filter added
> > > on the PF? Did you do sth else before checking tc?
> > 
> > Hi Michal,
> > I have used the setup with latest upstream dev-queue kernel and this issue is observed while adding HW tc rules on PF using
> > 'Script A' from below link.
> > https://edc.intel.com/content/www/us/en/design/products/ethernet/appnote-e810-eswitch-switchdev-mode-config-guide/script-a-switchdev-mode-with-linux-bridge-configuration/
> > 
> > This issue is reproducible on two of our setups with latest upstream kernel - 6.9.0-rc1+. Please check and let me know if more information is needed.
> > 
> 
> I tried script from the link and it is working. I am aware of the
> problem when the same rule is being added with different destination.
> Are you sure there are no more exsisting rule before calling the script?
> In the script VFs are removed, but PF qdisc isn't removed. Old rule can
> exsist there. I suggest to add sth like, before adding new qdiscs:
> $tc qdisc del dev $PF1 ingress
> 
> I tested on 6.9.0-rc1+ kernel.
> 

I have found the problem. I was using different DDP package.

The problem is with lack of free indexes in profiles when matching is
done on both tunnel and not tunnel packet (so all profiles are
considered). For now please Tony remove it from next-queue. I am trying
to figure out how to implement matching on all profiles using less
indexes. If I find the correct way I will submit new patch.

Thanks

> Thanks,
> Michal
> > Thanks,
> > Sujai B
> > > Thanks,
> > > Michal
> > > > Thanks,
> > > > Sujai B